# autogenerated
# mypy: ignore-errors
# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from rime_sdk.protos.ri.api.agent import agent_pb2 as ri_dot_api_dot_agent_dot_agent__pb2


class AgentManagerStub(object):
    """AgentManager is an interface for managing agents.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.CreateAgent = channel.unary_unary(
                '/rime.AgentManager/CreateAgent',
                request_serializer=ri_dot_api_dot_agent_dot_agent__pb2.CreateAgentRequest.SerializeToString,
                response_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.CreateAgentResponse.FromString,
                )
        self.ListAgents = channel.unary_unary(
                '/rime.AgentManager/ListAgents',
                request_serializer=ri_dot_api_dot_agent_dot_agent__pb2.ListAgentsRequest.SerializeToString,
                response_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.ListAgentsResponse.FromString,
                )
        self.GetAgent = channel.unary_unary(
                '/rime.AgentManager/GetAgent',
                request_serializer=ri_dot_api_dot_agent_dot_agent__pb2.GetAgentRequest.SerializeToString,
                response_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.GetAgentResponse.FromString,
                )
        self.RegisterInternalAgent = channel.unary_unary(
                '/rime.AgentManager/RegisterInternalAgent',
                request_serializer=ri_dot_api_dot_agent_dot_agent__pb2.RegisterInternalAgentRequest.SerializeToString,
                response_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.RegisterInternalAgentResponse.FromString,
                )
        self.DeactivateAgent = channel.unary_unary(
                '/rime.AgentManager/DeactivateAgent',
                request_serializer=ri_dot_api_dot_agent_dot_agent__pb2.DeactivateAgentRequest.SerializeToString,
                response_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.DeactivateAgentResponse.FromString,
                )
        self.DeleteAgent = channel.unary_unary(
                '/rime.AgentManager/DeleteAgent',
                request_serializer=ri_dot_api_dot_agent_dot_agent__pb2.DeleteAgentRequest.SerializeToString,
                response_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.DeleteAgentResponse.FromString,
                )
        self.Heartbeat = channel.unary_unary(
                '/rime.AgentManager/Heartbeat',
                request_serializer=ri_dot_api_dot_agent_dot_agent__pb2.HeartbeatRequest.SerializeToString,
                response_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.HeartbeatResponse.FromString,
                )


class AgentManagerServicer(object):
    """AgentManager is an interface for managing agents.
    """

    def CreateAgent(self, request, context):
        """CreateAgent

        This is a method for creating an agent and retrieving the configuration 
        for installing the agent.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def ListAgents(self, request, context):
        """ListAgents

        This is a paginated method for retrieving agents from the database.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetAgent(self, request, context):
        """GetAgent

        This fetches a single agent from the database.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RegisterInternalAgent(self, request, context):
        """RegisterInternalAgent is used by internal agents during startup to obtain
        an ID. This call is idempotent; it will be called by internal agent upon
        every restart. If no record of an internal agent exists, a new agent is
        created in the DB.Otherwise, the Agent Management service returns the ID
        of the existing agent.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DeactivateAgent(self, request, context):
        """DeactivateAgent deactivates the agent by setting its status to deactivated
        and revoking the agent's API Token. An error is returned if the
        deactivation fails.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DeleteAgent(self, request, context):
        """DeleteAgent removes the agent from the Agent Manager DB. It must only be 
        called on an already deactivated agent. An error is returned if the
        deletion fails or if the agent is not in a deletable state.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Heartbeat(self, request, context):
        """Heartbeat accepts heartbeat signal from agent indicating that they are
        still running.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_AgentManagerServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'CreateAgent': grpc.unary_unary_rpc_method_handler(
                    servicer.CreateAgent,
                    request_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.CreateAgentRequest.FromString,
                    response_serializer=ri_dot_api_dot_agent_dot_agent__pb2.CreateAgentResponse.SerializeToString,
            ),
            'ListAgents': grpc.unary_unary_rpc_method_handler(
                    servicer.ListAgents,
                    request_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.ListAgentsRequest.FromString,
                    response_serializer=ri_dot_api_dot_agent_dot_agent__pb2.ListAgentsResponse.SerializeToString,
            ),
            'GetAgent': grpc.unary_unary_rpc_method_handler(
                    servicer.GetAgent,
                    request_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.GetAgentRequest.FromString,
                    response_serializer=ri_dot_api_dot_agent_dot_agent__pb2.GetAgentResponse.SerializeToString,
            ),
            'RegisterInternalAgent': grpc.unary_unary_rpc_method_handler(
                    servicer.RegisterInternalAgent,
                    request_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.RegisterInternalAgentRequest.FromString,
                    response_serializer=ri_dot_api_dot_agent_dot_agent__pb2.RegisterInternalAgentResponse.SerializeToString,
            ),
            'DeactivateAgent': grpc.unary_unary_rpc_method_handler(
                    servicer.DeactivateAgent,
                    request_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.DeactivateAgentRequest.FromString,
                    response_serializer=ri_dot_api_dot_agent_dot_agent__pb2.DeactivateAgentResponse.SerializeToString,
            ),
            'DeleteAgent': grpc.unary_unary_rpc_method_handler(
                    servicer.DeleteAgent,
                    request_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.DeleteAgentRequest.FromString,
                    response_serializer=ri_dot_api_dot_agent_dot_agent__pb2.DeleteAgentResponse.SerializeToString,
            ),
            'Heartbeat': grpc.unary_unary_rpc_method_handler(
                    servicer.Heartbeat,
                    request_deserializer=ri_dot_api_dot_agent_dot_agent__pb2.HeartbeatRequest.FromString,
                    response_serializer=ri_dot_api_dot_agent_dot_agent__pb2.HeartbeatResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'rime.AgentManager', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class AgentManager(object):
    """AgentManager is an interface for managing agents.
    """

    @staticmethod
    def CreateAgent(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.AgentManager/CreateAgent',
            ri_dot_api_dot_agent_dot_agent__pb2.CreateAgentRequest.SerializeToString,
            ri_dot_api_dot_agent_dot_agent__pb2.CreateAgentResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def ListAgents(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.AgentManager/ListAgents',
            ri_dot_api_dot_agent_dot_agent__pb2.ListAgentsRequest.SerializeToString,
            ri_dot_api_dot_agent_dot_agent__pb2.ListAgentsResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def GetAgent(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.AgentManager/GetAgent',
            ri_dot_api_dot_agent_dot_agent__pb2.GetAgentRequest.SerializeToString,
            ri_dot_api_dot_agent_dot_agent__pb2.GetAgentResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RegisterInternalAgent(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.AgentManager/RegisterInternalAgent',
            ri_dot_api_dot_agent_dot_agent__pb2.RegisterInternalAgentRequest.SerializeToString,
            ri_dot_api_dot_agent_dot_agent__pb2.RegisterInternalAgentResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def DeactivateAgent(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.AgentManager/DeactivateAgent',
            ri_dot_api_dot_agent_dot_agent__pb2.DeactivateAgentRequest.SerializeToString,
            ri_dot_api_dot_agent_dot_agent__pb2.DeactivateAgentResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def DeleteAgent(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.AgentManager/DeleteAgent',
            ri_dot_api_dot_agent_dot_agent__pb2.DeleteAgentRequest.SerializeToString,
            ri_dot_api_dot_agent_dot_agent__pb2.DeleteAgentResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Heartbeat(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.AgentManager/Heartbeat',
            ri_dot_api_dot_agent_dot_agent__pb2.HeartbeatRequest.SerializeToString,
            ri_dot_api_dot_agent_dot_agent__pb2.HeartbeatResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
