# autogenerated
# mypy: ignore-errors
# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from google.protobuf import empty_pb2 as google_dot_protobuf_dot_empty__pb2
from rime_sdk.protos.workspace import workspace_pb2 as workspace_dot_workspace__pb2


class WorkspaceServiceStub(object):
    """CRUD endpoints for interacting with workspaces.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.CreateWorkspace = channel.unary_unary(
                '/rime.WorkspaceService/CreateWorkspace',
                request_serializer=workspace_dot_workspace__pb2.CreateWorkspaceRequest.SerializeToString,
                response_deserializer=workspace_dot_workspace__pb2.CreateWorkspaceResponse.FromString,
                )
        self.GetWorkspace = channel.unary_unary(
                '/rime.WorkspaceService/GetWorkspace',
                request_serializer=workspace_dot_workspace__pb2.GetWorkspaceRequest.SerializeToString,
                response_deserializer=workspace_dot_workspace__pb2.GetWorkspaceResponse.FromString,
                )
        self.UpdateWorkspace = channel.unary_unary(
                '/rime.WorkspaceService/UpdateWorkspace',
                request_serializer=workspace_dot_workspace__pb2.UpdateWorkspaceRequest.SerializeToString,
                response_deserializer=workspace_dot_workspace__pb2.UpdateWorkspaceResponse.FromString,
                )
        self.DeleteWorkspace = channel.unary_unary(
                '/rime.WorkspaceService/DeleteWorkspace',
                request_serializer=workspace_dot_workspace__pb2.DeleteWorkspaceRequest.SerializeToString,
                response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                )
        self.ListWorkspaces = channel.unary_unary(
                '/rime.WorkspaceService/ListWorkspaces',
                request_serializer=workspace_dot_workspace__pb2.ListWorkspacesRequest.SerializeToString,
                response_deserializer=workspace_dot_workspace__pb2.ListWorkspacesResponse.FromString,
                )


class WorkspaceServiceServicer(object):
    """CRUD endpoints for interacting with workspaces.
    """

    def CreateWorkspace(self, request, context):
        """CreateWorkspace

        Create a new workspace
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetWorkspace(self, request, context):
        """GetWorkspace

        Gets a single workspace by id.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def UpdateWorkspace(self, request, context):
        """UpdateWorkspace

        Updates an existing workspace.
        The ID in the provided workspace is used to identify it.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DeleteWorkspace(self, request, context):
        """DeleteWorkspace

        Deletes an existing workspace.
        The ID in the provided workspace is used to identify it.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def ListWorkspaces(self, request, context):
        """ListWorkspaces

        List workspaces with optional filter.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_WorkspaceServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'CreateWorkspace': grpc.unary_unary_rpc_method_handler(
                    servicer.CreateWorkspace,
                    request_deserializer=workspace_dot_workspace__pb2.CreateWorkspaceRequest.FromString,
                    response_serializer=workspace_dot_workspace__pb2.CreateWorkspaceResponse.SerializeToString,
            ),
            'GetWorkspace': grpc.unary_unary_rpc_method_handler(
                    servicer.GetWorkspace,
                    request_deserializer=workspace_dot_workspace__pb2.GetWorkspaceRequest.FromString,
                    response_serializer=workspace_dot_workspace__pb2.GetWorkspaceResponse.SerializeToString,
            ),
            'UpdateWorkspace': grpc.unary_unary_rpc_method_handler(
                    servicer.UpdateWorkspace,
                    request_deserializer=workspace_dot_workspace__pb2.UpdateWorkspaceRequest.FromString,
                    response_serializer=workspace_dot_workspace__pb2.UpdateWorkspaceResponse.SerializeToString,
            ),
            'DeleteWorkspace': grpc.unary_unary_rpc_method_handler(
                    servicer.DeleteWorkspace,
                    request_deserializer=workspace_dot_workspace__pb2.DeleteWorkspaceRequest.FromString,
                    response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            ),
            'ListWorkspaces': grpc.unary_unary_rpc_method_handler(
                    servicer.ListWorkspaces,
                    request_deserializer=workspace_dot_workspace__pb2.ListWorkspacesRequest.FromString,
                    response_serializer=workspace_dot_workspace__pb2.ListWorkspacesResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'rime.WorkspaceService', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class WorkspaceService(object):
    """CRUD endpoints for interacting with workspaces.
    """

    @staticmethod
    def CreateWorkspace(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.WorkspaceService/CreateWorkspace',
            workspace_dot_workspace__pb2.CreateWorkspaceRequest.SerializeToString,
            workspace_dot_workspace__pb2.CreateWorkspaceResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def GetWorkspace(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.WorkspaceService/GetWorkspace',
            workspace_dot_workspace__pb2.GetWorkspaceRequest.SerializeToString,
            workspace_dot_workspace__pb2.GetWorkspaceResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def UpdateWorkspace(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.WorkspaceService/UpdateWorkspace',
            workspace_dot_workspace__pb2.UpdateWorkspaceRequest.SerializeToString,
            workspace_dot_workspace__pb2.UpdateWorkspaceResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def DeleteWorkspace(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.WorkspaceService/DeleteWorkspace',
            workspace_dot_workspace__pb2.DeleteWorkspaceRequest.SerializeToString,
            google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def ListWorkspaces(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/rime.WorkspaceService/ListWorkspaces',
            workspace_dot_workspace__pb2.ListWorkspacesRequest.SerializeToString,
            workspace_dot_workspace__pb2.ListWorkspacesResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
